/*
 * Copyright (C) 1990-1992 by Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#ifndef	SVGA_H
#define	SVGA_H

/*
 * svga.h	- private SVGA data
 */

struct svga_mode_info
{
    int			width;
    int			height;
    int			depth;
    int			bios_mode;
    int			attributes;

    unsigned		scanline_length;
    unsigned char	*window_address;
    unsigned		window_size;
    unsigned		window_granularity;
    void		(*window_control)();

    unsigned char	red_bits;
    unsigned char	green_bits;
    unsigned char	blue_bits;
    unsigned char	red_shift;
    unsigned char	green_shift;
    unsigned char	blue_shift;
};

#define	SVGA_TEXT_MODE		1
#define	SVGA_GRAPHICS_MODE	2
#define SVGA_MODE_SUPPORTED	0x80

extern struct svga_mode_info	*SVGAModeTable;
extern struct svga_mode_info	*SVGAModeInfo;
extern int			SVGAMaxModeIndex;

extern unsigned char	*VideoBiosAddress;

#endif	/* SVGA_H */
