/*
 * Copyright (C) 1990-1992 by Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

/*
 * video device configuration
 */

#include	"vdev.h"

extern int	vga_probe();
extern int	vga_init();

extern int	vesa_probe();
extern int	vesa_init();

extern int	ati_probe();
extern int	ati_init();

extern int	tseng_probe();
extern int	tseng_init();

extern int	trident_probe();
extern int	trident_init();

extern int	paradise_probe();
extern int	paradise_init();

extern int	s3_probe();
extern int	s3_init();

/*
 * The order of the entries in this table determines the
 * auto-detection sequence for the video card.
 *
 * When adding a new entry to the table care must be taken to
 * ensure that it does not interfere with the correct auto-detection
 * of the other cards.
 *
 */
struct vdevinit	vdevsw[] =
{
    {	"VESA",		vesa_probe,	vesa_init	},
    {	"PARADISE",	paradise_probe,	paradise_init	},
    {	"ATI",		ati_probe,	ati_init	},
    {	"TRIDENT",	trident_probe,	trident_init	},
    {	"TSENG",	tseng_probe,	tseng_init	},
    {	"S3",		s3_probe,	s3_init		},
    {	"VGA",		vga_probe,	vga_init	},
    {	0,		0,		0		}
};
